# Uses of Class
org.apache.sysds.runtime.lineage.LineageItem

Packages that use LineageItem
Package
Description
org.apache.sysds.hops.recompile
org.apache.sysds.runtime.controlprogram.caching
org.apache.sysds.runtime.controlprogram.context
org.apache.sysds.runtime.controlprogram.federated
org.apache.sysds.runtime.instructions.cp
org.apache.sysds.runtime.instructions.fed
org.apache.sysds.runtime.instructions.gpu
org.apache.sysds.runtime.instructions.spark
org.apache.sysds.runtime.lineage
org.apache.sysds.runtime.util
org.apache.sysds.utils

## Uses of LineageItem in org.apache.sysds.hops.recompile

Methods in org.apache.sysds.hops.recompile with parameters of type LineageItem
Modifier and Type
Method
Description
`static void`
Recompiler.`executeInMemoryReblock(ExecutionContext ec, String varin, String varout, LineageItem litem)`

## Uses of LineageItem in org.apache.sysds.runtime.controlprogram.caching

Methods in org.apache.sysds.runtime.controlprogram.caching that return LineageItem
Modifier and Type
Method
Description
`LineageItem`
CacheableData.`getCacheLineage()`
Methods in org.apache.sysds.runtime.controlprogram.caching with parameters of type LineageItem
Modifier and Type
Method
Description
`void`
CacheableData.`setCacheLineage(LineageItem li)`

## Uses of LineageItem in org.apache.sysds.runtime.controlprogram.context

Methods in org.apache.sysds.runtime.controlprogram.context that return LineageItem
Modifier and Type
Method
Description
`LineageItem`
ExecutionContext.`getLineageItem(String varname)`
`LineageItem`
ExecutionContext.`getLineageItem(CPOperand input)`
`LineageItem`
ExecutionContext.`getOrCreateLineageItem(CPOperand input)`
Methods in org.apache.sysds.runtime.controlprogram.context with parameters of type LineageItem
Modifier and Type
Method
Description
`void`
ExecutionContext.`replaceLineageItem(String varname, LineageItem li)`
`void`
ExecutionContext.`setMatrixOutputAndLineage(String varName, Future<MatrixBlock> fmb, LineageItem li)`
`void`
ExecutionContext.`setMatrixOutputAndLineage(String varName, MatrixBlock outputData, LineageItem li)`
`void`
ExecutionContext.`setMatrixOutputAndLineage(CPOperand var, MatrixBlock outputData, LineageItem li)`

## Uses of LineageItem in org.apache.sysds.runtime.controlprogram.federated

Methods in org.apache.sysds.runtime.controlprogram.federated that return LineageItem
Modifier and Type
Method
Description
`LineageItem`
MatrixLineagePair.`getLI()`
`LineageItem`
FederatedResponse.`getLineageItem()`
Methods in org.apache.sysds.runtime.controlprogram.federated that return types with arguments of type LineageItem
Modifier and Type
Method
Description
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
FederatedData.GetPrivacyConstraints.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
FederatedStatistics.FedStatsCollectFunction.`getLineageItem(ExecutionContext ec)`
Methods in org.apache.sysds.runtime.controlprogram.federated with parameters of type LineageItem
Modifier and Type
Method
Description
`FederatedRequest[]`
FederationMap.`broadcastSliced(CacheableData<?> data, LineageItem lineageItem, boolean isFrame, int[][] ix)`
`static MatrixLineagePair`
MatrixLineagePair.`of(MatrixObject mo, LineageItem li)`
Constructors in org.apache.sysds.runtime.controlprogram.federated with parameters of type LineageItem
Modifier
Constructor
Description
``
`FederatedRequest(FederatedRequest.RequestType method, LineageItem linItem, long id, Object... data)`
``
`FederatedResponse(FederatedResponse.ResponseType status, Object[] data, LineageItem linItem)`
``
`FederatedResponse(FederatedResponse.ResponseType status, Object data, LineageItem linItem)`
``
`MatrixLineagePair(MatrixObject mo, LineageItem li)`

## Uses of LineageItem in org.apache.sysds.runtime.instructions.cp

Methods in org.apache.sysds.runtime.instructions.cp that return LineageItem
Modifier and Type
Method
Description
`LineageItem`
UnaryMatrixCPInstruction.`getCacheLineageItem(LineageItem input)`
`LineageItem`
ListObject.`getLineageItem(int ix)`
`LineageItem`
ListObject.`getLineageItem(String name)`
`LineageItem`
CPOperand.`getLiteralLineageItem()`
Methods in org.apache.sysds.runtime.instructions.cp that return types with arguments of type LineageItem
Modifier and Type
Method
Description
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ComputationCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
CtableCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
DataGenCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
DnnCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
FrameIndexingCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ListIndexingCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MatrixAppendCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MatrixBuiltinNaryCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MatrixIndexingCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ParameterizedBuiltinCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ReshapeCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ScalarBuiltinNaryCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
SpoofCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
StringInitCPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
VariableCPInstruction.`getLineageItem(ExecutionContext ec)`
`List<LineageItem>`
ListObject.`getLineageItems()`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>[]`
MultiReturnBuiltinCPInstruction.`getLineageItems(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>[]`
MultiReturnComplexMatrixBuiltinCPInstruction.`getLineageItems(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>[]`
MultiReturnParameterizedBuiltinCPInstruction.`getLineageItems(ExecutionContext ec)`
Methods in org.apache.sysds.runtime.instructions.cp with parameters of type LineageItem
Modifier and Type
Method
Description
`ListObject`
ListObject.`add(String name, Data dat, LineageItem li)`
`ListObject`
ListObject.`add(Data dat, LineageItem li)`
`LineageItem`
UnaryMatrixCPInstruction.`getCacheLineageItem(LineageItem input)`
`ListObject`
ListObject.`set(int ix, Data data, LineageItem li)`
`Data`
ListObject.`set(String name, Data data, LineageItem li)`
Constructors in org.apache.sysds.runtime.instructions.cp with parameters of type LineageItem
Modifier
Constructor
Description
``
`FunctionCallCPInstruction(String namespace, String functName, boolean opt, CPOperand[] boundInputs, LineageItem[] lineageInputs, List<String> funArgNames, List<String> boundOutputNames, String istr)`
``
`TriggerPrefetchTask(MatrixObject mo, LineageItem li)`

## Uses of LineageItem in org.apache.sysds.runtime.instructions.fed

Methods in org.apache.sysds.runtime.instructions.fed that return types with arguments of type LineageItem
Modifier and Type
Method
Description
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ComputationFEDInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
InitFEDInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MultiReturnParameterizedBuiltinFEDInstruction.CreateFrameEncoder.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MultiReturnParameterizedBuiltinFEDInstruction.ExecuteFrameEncoder.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ParameterizedBuiltinFEDInstruction.DecodeMatrix.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
QuantilePickFEDInstruction.CreateMatrixFromFrame.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
QuantilePickFEDInstruction.GetHistogram.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
QuantilePickFEDInstruction.GetValuesInRange.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
QuantilePickFEDInstruction.GetValuesInRanges.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
QuantilePickFEDInstruction.MinMax.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ReorgFEDInstruction.DiagMatrix.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ReorgFEDInstruction.Rdiag.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ReorgFEDInstruction.SliceMatrix.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ReshapeFEDInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
VariableFEDInstruction.`getLineageItem(ExecutionContext ec)`

## Uses of LineageItem in org.apache.sysds.runtime.instructions.gpu

Methods in org.apache.sysds.runtime.instructions.gpu that return types with arguments of type LineageItem
Modifier and Type
Method
Description
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
DnnGPUInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
GPUInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MatrixIndexingGPUInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MatrixReshapeGPUInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
SpoofCUDAInstruction.`getLineageItem(ExecutionContext ec)`

## Uses of LineageItem in org.apache.sysds.runtime.instructions.spark

Methods in org.apache.sysds.runtime.instructions.spark that return types with arguments of type LineageItem
Modifier and Type
Method
Description
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
BuiltinNarySPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
CheckpointSPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ComputationSPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MapmmChainSPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
MatrixIndexingSPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ParameterizedBuiltinSPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
RandSPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
ReblockSPInstruction.`getLineageItem(ExecutionContext ec)`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
WriteSPInstruction.`getLineageItem(ExecutionContext ec)`

## Uses of LineageItem in org.apache.sysds.runtime.lineage

Methods in org.apache.sysds.runtime.lineage that return LineageItem
Modifier and Type
Method
Description
`static LineageItem`
LineageItemUtils.`createScalarLineageItem(LiteralOp lop)`
`LineageItem`
LineageItem.`deepCopy()`
`static LineageItem`
Lineage.`deserializeSingleTrace(String serialLinTrace)`
`static LineageItem`
LineageDebugger.`firstOccurrenceOfNR(LineageItem li, int pos)`
`LineageItem`
Lineage.`get(String varName)`
`LineageItem`
Lineage.`get(CPOperand variable)`
`LineageItem`
LineageMap.`get(String varName)`
`LineageItem`
LineageMap.`get(CPOperand variable)`
`static LineageItem`
LineageCodegenItem.`getCodegenLTrace(String classname)`
`LineageItem`
LineageItem.`getDedupPatch()`
`LineageItem[]`
LineageItem.`getInputs()`
`static LineageItem[]`
LineageItemUtils.`getLineage(ExecutionContext ec, CPOperand... operands)`
`static LineageItem[]`
LineageItemUtils.`getLineageItemInputstoSB(ArrayList<String> inputs, ExecutionContext ec)`
`LineageItem`
Lineage.`getOrCreate(CPOperand variable)`
`LineageItem`
LineageMap.`getOrCreate(CPOperand variable)`
`static LineageItem`
LineageItemUtils.`getSerializedFedResponseLineageItem(LineageItem li)`
`static LineageItem`
LineageParser.`parseLineageTrace(String str)`
`static LineageItem`
LineageParser.`parseLineageTrace(String str, String name)`
`static LineageItem`
LineageItemUtils.`rDecompress(LineageItem item)`
Deprecated.
`LineageItem`
LineageMap.`removeLineageItem(String key)`
`static LineageItem`
LineageItemUtils.`replace(LineageItem root, LineageItem liOld, LineageItem liNew)`
`LineageItem`
LineageMap.`set(String varName, LineageItem li)`
`static LineageItem`
LineageCodegenItem.`setCodegenLTrace(String classname, LineageItem li)`
`LineageItem`
LineageMap.`setLiteral(String varName, LineageItem li)`
Methods in org.apache.sysds.runtime.lineage that return types with arguments of type LineageItem
Modifier and Type
Method
Description
`static Map<LineageItem,LineageCacheEntry>`
LineageCache.`getLineageCache()`
`org.apache.commons.lang3.tuple.Pair<String,LineageItem>`
LineageTraceable.`getLineageItem(ExecutionContext ec)`
Obtain lineage trace of an instruction with a single output.
`default org.apache.commons.lang3.tuple.Pair<String,LineageItem>[]`
LineageTraceable.`getLineageItems(ExecutionContext ec)`
Obtain lineage trace of an instruction with multiple outputs.
`Map<String,LineageItem>`
LineageMap.`getLiterals()`
`Map<String,LineageItem>`
LineageMap.`getTraces()`
Methods in org.apache.sysds.runtime.lineage with parameters of type LineageItem
Modifier and Type
Method
Description
`static void`
LineageItemUtils.`checkCycles(LineageItem current)`
`static boolean`
LineageItemUtils.`containsRandDataGen(HashSet<LineageItem> entries, LineageItem root)`
`static String`
LineageItemUtils.`explainLineageAsInstruction(LineageItem li, Statistics.LineageNGramExtension ext)`
`static String`
LineageItemUtils.`explainLineageType(LineageItem li, Statistics.LineageNGramExtension ext)`
`static String`
LineageItemUtils.`explainLineageWithTypes(LineageItem li, Statistics.LineageNGramExtension ext)`
`static String`
LineageItemUtils.`explainSingleLineageItem(LineageItem li)`
`static LineageItem`
LineageDebugger.`firstOccurrenceOfNR(LineageItem li, int pos)`
`static LineageCacheEntry`
LineageCache.`getEntry(LineageItem key)`
`static MatrixBlock`
LineageCache.`getMatrix(LineageItem key)`
`static LineageItem`
LineageItemUtils.`getSerializedFedResponseLineageItem(LineageItem li)`
`static boolean`
LineageCache.`probe(LineageItem key)`
`void`
LineageMap.`processDedupItem(LineageMap lm, Long path, LineageItem[] liinputs, String name, Map<String,Integer> dpatchHashList)`
`static void`
LineageEstimator.`processFunc(List<DataIdentifier> outputs, LineageItem[] liInputs, String name, ExecutionContext ec, long computetime)`
`static void`
LineageCache.`putFedReadObject(Data data, LineageItem li, ExecutionContext ec)`
`static void`
LineageCache.`putSerializedObject(byte[] serialBytes, LineageItem objLI, long computetime)`
`static void`
LineageCache.`putValue(List<DataIdentifier> outputs, LineageItem[] liInputs, String name, ExecutionContext ec, long computetime)`
`static void`
LineageCache.`putValueAsyncOp(LineageItem instLI, Data data, MatrixBlock mb, long starttime)`
`static void`
LineageItemUtils.`rCheckCycles(LineageItem current, Set<Long> probe, boolean useObjIdent)`
`static LineageItem`
LineageItemUtils.`rDecompress(LineageItem item)`
Deprecated.
`static void`
LineageCache.`removeEntry(LineageItem key)`
`static LineageItem`
LineageItemUtils.`replace(LineageItem root, LineageItem liOld, LineageItem liNew)`
`static void`
LineageItemUtils.`replaceDagLeaves(ExecutionContext ec, LineageItem root, CPOperand[] newLeaves)`
`static void`
LineageItem.`resetVisitStatus(LineageItem[] lis)`
Deprecated.
`static void`
LineageItem.`resetVisitStatusNR(LineageItem[] lis)`
Non-recursive equivalent of `resetVisitStatus(LineageItem[])` for robustness with regard to stack overflow errors.
`static boolean`
LineageCache.`reuse(List<String> outNames, List<DataIdentifier> outParams, int numOutputs, LineageItem[] liInputs, String name, ExecutionContext ec)`
`static boolean`
LineageCache.`reuseFedRead(String outName, Types.DataType dataType, LineageItem li, ExecutionContext ec)`
`static byte[]`
LineageCache.`reuseSerialization(LineageItem objLI)`
`static void`
LineageItemUtils.`rGetDagLeaves(HashSet<LineageItem> leaves, LineageItem root)`
`static void`
LineageItemUtils.`rReplaceDagLeaves(LineageItem root, LineageItem[] newleaves)`
`static void`
LineageItemUtils.`rReplaceNR(LineageItem current, LineageItem liOld, LineageItem liNew)`
Non-recursive equivalent of `LineageItemUtils.rReplace(LineageItem, LineageItem, LineageItem)` for robustness with regard to stack overflow errors.
`static String`
Lineage.`serializeSingleTrace(LineageItem linItem)`
`void`
Lineage.`set(String varName, LineageItem li)`
`LineageItem`
LineageMap.`set(String varName, LineageItem li)`
`static LineageItem`
LineageCodegenItem.`setCodegenLTrace(String classname, LineageItem li)`
`void`
LineageItem.`setInput(int i, LineageItem item)`
`void`
Lineage.`setLiteral(String varName, LineageItem li)`
`LineageItem`
LineageMap.`setLiteral(String varName, LineageItem li)`
`static void`
LineageEstimator.`stopEstimator(List<DataIdentifier> outputs, LineageItem[] liInputs, String name)`
Method parameters in org.apache.sysds.runtime.lineage with type arguments of type LineageItem
Modifier and Type
Method
Description
`static boolean`
LineageItemUtils.`containsRandDataGen(HashSet<LineageItem> entries, LineageItem root)`
`static void`
LineageItemUtils.`rConstructLineageFromHops(Hop root, Hop[] inputs, Map<Long,LineageItem> operands, HashMap<Long,Hop> spoofmap)`
`static void`
LineageCacheEviction.`removeAll(Map<LineageItem,LineageCacheEntry> cache)`
`static void`
LineageItemUtils.`rGetDagLeaves(HashSet<LineageItem> leaves, LineageItem root)`
Constructors in org.apache.sysds.runtime.lineage with parameters of type LineageItem
Modifier
Constructor
Description
``
`LineageCacheEntry(LineageItem key, Types.DataType dt, MatrixBlock Mval, ScalarObject Sval, long computetime)`
``
`LineageItem(long id, String data, String opcode, LineageItem[] inputs, int specialValueBits)`
``
`LineageItem(long id, LineageItem li)`
``
`LineageItem(String data, String opcode, LineageItem[] inputs)`
``
`LineageItem(String opcode, LineageItem[] inputs)`
``
`LineageItem(String opcode, LineageItem dedupPatch, int dpatchHash, LineageItem[] inputs)`
``
`LineageItem(String opcode, LineageItem dedupPatch, LineageItem[] inputs)`
``
`LineageItem(LineageItem li)`

## Uses of LineageItem in org.apache.sysds.runtime.util

Methods in org.apache.sysds.runtime.util with parameters of type LineageItem
Modifier and Type
Method
Description
`static ArrayList<Hop>`
AutoDiff.`constructHopsNR(LineageItem item, Map<Long,Hop> operands, Hop mo, ArrayList<String> names)`

## Uses of LineageItem in org.apache.sysds.utils

Methods in org.apache.sysds.utils that return types with arguments of type LineageItem
Modifier and Type
Method
Description
`static Optional<Map.Entry<String,LineageItem>>`
Statistics.`getCurrentLineageItem()`
Methods in org.apache.sysds.utils with parameters of type LineageItem
Modifier and Type
Method
Description
`static String`
Explain.`explain(LineageItem li)`
`static String`
Explain.`explainLineageItems(LineageItem[] lis)`
`static String`
Explain.`explainLineageItems(LineageItem[] lis, int level)`
`static void`
Statistics.`extendLineageItem(LineageItem li, Statistics.LineageNGramExtension ext)`
`static Statistics.LineageNGramExtension`
Statistics.`getExtendedLineage(LineageItem li)`
`static void`
Statistics.`maintainNGramsFromLineage(LineageItem li)`
Method parameters in org.apache.sysds.utils with type arguments of type LineageItem
Modifier and Type
Method
Description
`static void`
Statistics.`prepareNGramInst(Map.Entry<String,LineageItem> li)`